%define NSIG		64		;x64_86
%define SIGHUP		 1
%define SIGINT		 2
%define SIGQUIT		 3
%define SIGILL		 4
%define SIGTRAP		 5
%define SIGABRT		 6
%define SIGIOT		 6
%define SIGBUS		 7
%define SIGFPE		 8
%define SIGKILL		 9
%define SIGUSR1		10
%define SIGSEGV		11
%define SIGUSR2		12
%define SIGPIPE		13
%define SIGALRM		14
%define SIGTERM		15
%define SIGSTKFLT	16
%define SIGCHLD		17
%define SIGCONT		18
%define SIGSTOP		19
%define SIGTSTP		20
%define SIGTTIN		21
%define SIGTTOU		22
%define SIGURG		23
%define SIGXCPU		24
%define SIGXFSZ		25
%define SIGVTALRM	26
%define SIGPROF		27
%define SIGWINCH	28
%define SIGIO		29
%define SIGPWR		30
%define SIGSYS		31
%define SIGRTMIN	32
%define SIGRT_1		33
%define SIGRT_2		34
%define SIGRT_3		35
%define SIGRT_4		36
%define SIGRT_5		37
%define SIGRT_6		38
%define SIGRT_7		39
%define SIGRT_8		40
%define SIGRT_9		41
%define SIGRT_10	42
%define SIGRT_11	43
%define SIGRT_12	44
%define SIGRT_13	45
%define SIGRT_14	46
%define SIGRT_15	47
%define SIGRT_16	48
%define SIGRT_17	49
%define SIGRT_18	50
%define SIGRT_19	51
%define SIGRT_20	52
%define SIGRT_21	53
%define SIGRT_22	54
%define SIGRT_23	55
%define SIGRT_24	56
%define SIGRT_25	57
%define SIGRT_26	58
%define SIGRT_27	59
%define SIGRT_28	60
%define SIGRT_29	61
%define SIGRT_30	62
%define SIGRT_31	63
%define SIGRT_32	64

%define SI_USER		0		; sent by kill, sigsend, raise */
%define SI_KERNEL	0x80		; sent by the kernel from somewhere */
%define SI_QUEUE	-1		; sent by sigqueue */
%define SI_TIMER __SI_CODE(__SI_TIMER,-2) ; sent by timer expiration */
%define SI_MESGQ __SI_CODE(__SI_MESGQ,-3) ; sent by real time mesq state change */
%define SI_ASYNCIO	-4		; sent by AIO completion */
%define SI_SIGIO	-5		; sent by queued SIGIO */
%define SI_TKILL	-6		; sent by tkill system call */
%define SI_DETHREAD	-7		; sent by execve() killing subsidiary threads */

%define SA_NOCLDSTOP	0x00000001
%define SA_NOCLDWAIT	0x00000002
%define SA_SIGINFO	0x00000004
%define SA_ONSTACK	0x08000000
%define SA_RESTART	0x10000000
%define SA_NODEFER	0x40000000
%define SA_RESETHAND	0x80000000
%define SA_RESTORER	0x04000000

%define MINSIGSTKSZ	2048
%define SIGSTKSZ	8192
%define SS_DISABLE	0
%define SS_ONSTACK	1

%define SIG_ERR		-1
%define SIG_DFL		0		;/* Default action.  */
%define SIG_IGN		1		;/* Ignore signal.  */

%define	SIG_BLOCK     0		 	;/* Block signals.  */
%define	SIG_UNBLOCK   1		 	;/* Unblock signals.  */
%define	SIG_SETMASK   2		 	;/* Set the set of blocked signals.  */

%define POLLIN		0x001		;* There is data to read.  *;
%define POLLPRI		0x002		;* There is urgent data to read.  *;
%define POLLOUT		0x004		;* Writing now will not block.  *;
;* These values are defined in XPG4.2.  *;
%define POLLRDNORM	0x040		;* Normal data may be read.  *;
%define POLLRDBAND	0x080		;* Priority data may be read.  *;
%define POLLWRNORM	0x100		;* Writing now will not block.  *;
%define POLLWRBAND	0x200		;* Priority data may be written.  *;
;* These are extensions for Linux.  *;
%define POLLMSG	0x400
%define POLLREMOVE	0x1000
%define POLLRDHUP	0x2000
;* Event types always implicitly polled for.  These bits need not be set in
 ;  `events', but they will appear in `revents' to indicate the status of
;   the file descriptor.  *;
%define POLLERR		0x008		;* Error condition.  *;
%define POLLHUP		0x010		;* Hung up.  *;
%define POLLNVAL	0x020		;* Invalid polling request.  *;

;/bits/fcntl.h
%define O_RD		0o
%define O_WR		1o
%define O_ASYNC		020000o
%define F_SETFL		4
%define F_SETOWN	8	;/* Get owner of socket (receiver of SIGIO).  */
%define F_GETOWN	9
%define F_SETSIG	10	;/* Set number of signal to be sent.  */
%define F_GETSIG	11	;/* Get number of signal to be sent.  */

;    MSG_OOB		= 0x01,	; Process out-of-band data.  */
%define MSG_OOB		0x01
 ;   MSG_PEEK		= 0x02,	; Peek at incoming messages.  */
%define MSG_PEEK	0x02
 ;   MSG_DONTROUTE	= 0x04,	; Don't use local routing.  */
%define MSG_DONTROUTE	0x04
 ;   MSG_CTRUNC		= 0x08,	; Control data lost before delivery.  */
%define MSG_CTRUNC	0x08
 ;   MSG_PROXY		= 0x10,	; Supply or ask second address.  */
%define MSG_PROXY	0x10
 ;   MSG_TRUNC		= 0x20,
%define	MSG_TRUNC	0x20
 ;   MSG_DONTWAIT	= 0x40, ; Nonblocking IO.  */
%define	MSG_DONTWAIT	0x40
 ;   MSG_EOR		= 0x80, ; End of record.  */
%define	MSG_EOR		0x80
 ;   MSG_WAITALL		= 0x100, ; Wait for a full request.  */
%define	MSG_WAITALL	0x100
 ;   MSG_FIN		= 0x200,
%define	MSG_FIN		0x200
 ;   MSG_SYN		= 0x400,
%define	MSG_SYN		0x400
 ;   MSG_CONFIRM		= 0x800, ; Confirm path validity.  */
%define	MSG_CONFIRM	0x800
 ;   MSG_RST		= 0x1000,
%define	MSG_RST		0x1000
 ;   MSG_ERRQUEUE	= 0x2000, ; Fetch message from error queue.  */
%define	MSG_ERRQUEUE	0x2000
 ;   MSG_NOSIGNAL	= 0x4000, ; Do not generate SIGPIPE.  */
%define	MSG_NOSIGNAL	0x4000
 ;   MSG_MORE		= 0x8000,  ; Sender will send more.  */
%define	MSG_MORE	0x8000
%define	MSG_CMSG_CLOEXEC	0x40000000

%define CSIGNAL       		0x000000ff ; Signal mask to be sent at exit.  
%define CLONE_VM      		0x00000100 ; Set if VM shared between processes.  
%define CLONE_FS      		0x00000200 ; Set if fs info shared between processes.  
%define CLONE_FILES   		0x00000400 ; Set if open files shared between processes.  
%define CLONE_SIGHAND 		0x00000800 ; Set if signal handlers shared.  
%define CLONE_PTRACE  		0x00002000 ; Set if tracing continues on the child.  
%define CLONE_VFORK   		0x00004000 ; Set if the parent wants the child to
				 ;    wake it up on mm_release.  
%define CLONE_PARENT  		0x00008000 ; Set if we want to have the same
				 ;    parent as the cloner.  
%define CLONE_THREAD  		0x00010000 ; Set to add to same thread group.  
%define CLONE_NEWNS   		0x00020000 ; Set to create new namespace.  
%define CLONE_SYSVSEM 		0x00040000 ; Set to shared SVID SEM_UNDO semantics.  
%define CLONE_SETTLS  		0x00080000 ; Set TLS info.  
%define CLONE_PARENT_SETTID 	0x00100000 ; Store TID in userlevel buffer
				;	   before MM copy.  
%define CLONE_CHILD_CLEARTID 	0x00200000 ; Register exit futex and memory
				;	    location to clear.  
%define CLONE_DETACHED 		0x00400000 ; Create clone detached.  
%define CLONE_UNTRACED 		0x00800000 ; Set if the tracing process can't
				  ;    force CLONE_PTRACE on this clone.  
%define CLONE_CHILD_SETTID 	0x01000000 ; Store TID in userlevel buffer in
					;  the child.  
%define CLONE_STOPPED		0x02000000 ; Start in stopped state.  


%define AF_INET		2
%define	AF_PACKET	17
%define	AF_UNIX		1
%define	AF_NETLINK	16

%define IPPROTO_IP	0
%define IPPROTO_TCP	6
%define IPPROTO_UDP	17
%define IPPROTO_ICMP	1
%define IPPROTO_IGMP	2
%define IPPROTO_RAW	255

%define SOCK_STREAM	1
%define SOCK_DGRAM	2
%define SOCK_RAW	3
%define SOCK_RDM	4
%define SOCK_SEQPACKET	5
%define SOCK_PACKET	10

%define SOL_SOCKET	1
%define SOL_IP		0
%define SOL_TCP		6
%define SOL_PACKET	263
%define SOL_RAW		255

%define IP_TOS		1
%define IP_OPTIONS      4
%define IP_HDRINCL      3
%define IP_TTL		2
%define IP_RECVOPTS	6
%define IP_RECVRETOPTS  IP_RETOPTS
%define IP_RETOPTS	7

%define	TCP_MAXWIN	65528

%define ETH_P_IP	0800h		;/* Internet Protocol packet	*/
%define ETH_P_LOOP	0060h		;/* Ethernet Loopback packet	*/
%define ETH_P_ARP	0806h		;/* Address Resolution packet	*/
%define ETH_P_ALL	0003h		;/* Every packet (be careful!!!) */

%define SO_REUSEADDR	2

%define	TCP_MAXWIN	65535

%define SO_DEBUG	1
%define SO_REUSEADDR	2
%define SO_TYPE		3
%define SO_ERROR	4
%define SO_DONTROUTE	5
%define SO_BROADCAST	6
%define SO_SNDBUF	7
%define SO_RCVBUF	8
%define SO_SNDBUFFORCE	32
%define SO_RCVBUFFORCE	33
%define SO_KEEPALIVE	9
%define SO_OOBINLINE	10
%define SO_NO_CHECK	11
%define SO_PRIORITY	12
%define SO_LINGER	13
%define SO_BSDCOMPAT	14
;/* To add :%define SO_REUSEPORT 15 */
%define SO_PASSCRED	16
%define SO_PEERCRED	17
%define SO_RCVLOWAT	18
%define SO_SNDLOWAT	19
%define SO_RCVTIMEO	20
%define SO_SNDTIMEO	21
;/* Security levels - as per NRL IPv6 - don't actually do anything */
%define SO_SECURITY_AUTHENTICATION		22
%define SO_SECURITY_ENCRYPTION_TRANSPORT	23
%define SO_SECURITY_ENCRYPTION_NETWORK		24
%define SO_BINDTODEVICE	25
;/* Socket filtering */
%define SO_ATTACH_FILTER        26
%define SO_DETACH_FILTER        27
%define SO_PEERNAME		28
%define SO_TIMESTAMP		29
%define SCM_TIMESTAMP		SO_TIMESTAMP
%define SO_ACCEPTCONN		30
%define SO_PEERSEC		31
%define SO_PASSSEC		34
%define SO_TIMESTAMPNS		35
%define SCM_TIMESTAMPNS		SO_TIMESTAMPNS
%define SO_MARK			36

;/* Socket-level I/O control calls. */
%define FIOSETOWN	0x8901
%define SIOCSPGRP	0x8902
%define FIOGETOWN	0x8903
%define SIOCGPGRP	0x8904
%define SIOCATMARK	0x8905
%define SIOCGSTAMP	0x8906		; Get stamp (timeval) */
%define SIOCGSTAMPNS	0x8907		; Get stamp (timespec) */

%define O_ACCMODE	3o
%define O_RDONLY	0o
%define O_WRONLY	1o
%define O_RDWR		2o
%define O_CREAT		100o		; not fcntl */
%define O_EXCL		200o		; not fcntl */
%define O_NOCTTY	400o		; not fcntl */
%define O_TRUNC		1000o		; not fcntl */
%define O_APPEND	2000o
%define O_NONBLOCK	4000o
%define O_SYNC		10000o
%define FASYNC		20000o		; fcntl, for BSD compatibility */
%define O_DIRECT	40000o		; direct disk access hint */
%define O_LARGEFILE	100000o
%define O_DIRECTORY	200000o		; must be a directory */
%define O_NOFOLLOW	400000o		; don't follow links */
%define O_NOATIME	1000000o
%define O_CLOEXEC	2000000o	; set close_on_exec */

%define DT_UNKNOWN	0	;The file type is unknown. 
%define DT_FIFO		1	;This is a named pipe (FIFO). 
%define DT_CHR		2	;This is a character device. 
%define DT_DIR		4	;This is a directory. 
%define DT_BLK		6	;This is a block device
%define DT_REG		8	;This is a regular file. 
%define DT_LNK		10	;This is a symbolic link. 0ah
%define DT_SOCK		12	;This is a Unix domain socket. 0ch
%define DT_WHT		14	;0eh


%define MAP_32BIT	0x40		; only give out 32bit addresses

%define MAP_GROWSDOWN	0x0100		; stack-like segment
%define MAP_DENYWRITE	0x0800		; ETXTBSY
%define MAP_EXECUTABLE	0x1000		; mark it as an executable
%define MAP_LOCKED	0x2000		; pages are locked
%define MAP_NORESERVE	0x4000		; don't check for reservations
%define MAP_POPULATE	0x8000		; populate (prefault) pagetables
%define MAP_NONBLOCK	0x10000		; do not block on IO

%define MCL_CURRENT	1		; lock all current mappings
%define MCL_FUTURE	2		; lock all future mappings

%define PROT_READ	0x1		; page can be read
%define PROT_WRITE	0x2		; page can be written
%define PROT_EXEC	0x4		; page can be executed
%define PROT_SEM	0x8		; page may be used for atomic ops
%define PROT_NONE	0x0		; page can not be accessed
%define PROT_GROWSDOWN	0x01000000	; mprotect flag: extend change to start of growsdown vma
%define PROT_GROWSUP	0x02000000	; mprotect flag: extend change to end of growsup vma

%define MAP_SHARED	0x01		; Share changes
%define MAP_PRIVATE	0x02		; Changes are private
%define MAP_TYPE	0x0f		; Mask for type of mapping
%define MAP_FIXED	0x10		; Interpret addr exactly
%define MAP_ANONYMOUS	0x20		; don't use a file

%define MS_ASYNC	1		; sync memory asynchronously
%define MS_INVALIDATE	2		; invalidate the caches
%define MS_SYNC		4		; synchronous memory sync

%define MADV_NORMAL	0		; no further special treatment
%define MADV_RANDOM	1		; expect random page references
%define MADV_SEQUENTIAL	2		; expect sequential page references
%define MADV_WILLNEED	3		; will need these pages
%define MADV_DONTNEED	4		; don't need these pages

; common parameters: try to keep these consistent across architectures
%define MADV_REMOVE	9		; remove these pages & resources
%define MADV_DONTFORK	10		; don't inherit across fork
%define MADV_DOFORK	11		; do inherit across fork

; compatibility flags
%define MAP_FILE	0

%define	WNOHANG		1		;* Don't block waiting.  *;
;%define WUNTRACED	2		;* Report status of stopped children.  *;
%define WSTOPPED	2		;* Report stopped child (same as WUNTRACED). *;
%define WEXITED		4		;* Report dead child.  *;
%define WCONTINUED	8		;* Report continued child.  *;
%define WNOWAIT		0x01000000 	;* Don't reap, just poll status.  *;
%define __WNOTHREAD     0x20000000 	;* Don't wait on children of other threads
%define __WALL		0x40000000 	;* Wait for any child.  *;
%define __WCLONE	0x80000000 	;* Wait for cloned process.  *;

%define AT_FDCWD		-100	;/* Special value used to indicate
					;   the *at functions should use the
					;   current working directory. */
%define AT_SYMLINK_NOFOLLOW	0x100	;/* Do not follow symbolic links.  */
%define AT_REMOVEDIR		0x200	;/* Remove directory instead of
					;   unlinking file.  */
%define AT_SYMLINK_FOLLOW	0x400	;/* Follow symbolic links.  */
%define AT_EACCESS		0x200	;/* Test access permitted for
					;  effective IDs, not real IDs.  */

%define ICMP_FILTER			1

%define ICMP_ECHOREPLY		0	; Echo Reply			*/
%define ICMP_DEST_UNREACH	3	; Destination Unreachable	*/
%define ICMP_SOURCE_QUENCH	4	; Source Quench		*/
%define ICMP_REDIRECT		5	; Redirect (change route)	*/
%define ICMP_ECHO		8	; Echo Request			*/
%define ICMP_TIME_EXCEEDED	11	; Time Exceeded		*/
%define ICMP_PARAMETERPROB	12	; Parameter Problem		*/
%define ICMP_TIMESTAMP		13	; Timestamp Request		*/
%define ICMP_TIMESTAMPREPLY	14	; Timestamp Reply		*/
%define ICMP_INFO_REQUEST	15	; Information Request		*/
%define ICMP_INFO_REPLY		16	; Information Reply		*/
%define ICMP_ADDRESS		17	; Address Mask Request		*/
%define ICMP_ADDRESSREPLY	18	; Address Mask Reply		*/
%define NR_ICMP_TYPES		18


; Codes for UNREACH. */
%define ICMP_NET_UNREACH	0	; Network Unreachable		*/
%define ICMP_HOST_UNREACH	1	; Host Unreachable		*/
%define ICMP_PROT_UNREACH	2	; Protocol Unreachable		*/
%define ICMP_PORT_UNREACH	3	; Port Unreachable		*/
%define ICMP_FRAG_NEEDED	4	; Fragmentation Needed/DF set	*/
%define ICMP_SR_FAILED		5	; Source Route failed		*/
%define ICMP_NET_UNKNOWN	6
%define ICMP_HOST_UNKNOWN	7
%define ICMP_HOST_ISOLATED	8
%define ICMP_NET_ANO		9
%define ICMP_HOST_ANO		10
%define ICMP_NET_UNR_TOS	11
%define ICMP_HOST_UNR_TOS	12
%define ICMP_PKT_FILTERED	13	; Packet filtered */
%define ICMP_PREC_VIOLATION	14	; Precedence violation */
%define ICMP_PREC_CUTOFF	15	; Precedence cut off */
%define NR_ICMP_UNREACH		15	; instead of hardcoding immediate value */

; Codes for REDIRECT. */
%define ICMP_REDIR_NET		0	; Redirect Net			*/
%define ICMP_REDIR_HOST		1	; Redirect Host		*/
%define ICMP_REDIR_NETTOS	2	; Redirect Net for TOS		*/
%define ICMP_REDIR_HOSTTOS	3	; Redirect Host for TOS	*/

; Codes for TIME_EXCEEDED. */
%define ICMP_EXC_TTL		0	; TTL count exceeded		*/
%define ICMP_EXC_FRAGTIME	1	; Fragment Reass time exceeded	*/

; ARP protocol HARDWARE identifiers. */
%define ARPHRD_NETROM	0		; from KA9Q: NET/ROM pseudo	*/
%define ARPHRD_ETHER 	1		; Ethernet 10Mbps		*/
%define	ARPHRD_EETHER	2		; Experimental Ethernet	*/
%define	ARPHRD_AX25	3		; AX.25 Level 2		*/
%define	ARPHRD_PRONET	4		; PROnet token ring		*/
%define	ARPHRD_CHAOS	5		; Chaosnet			*/
%define	ARPHRD_IEEE802	6		; IEEE 802.2 Ethernet/TR/TB	*/
%define	ARPHRD_ARCNET	7		; ARCnet			*/
%define	ARPHRD_APPLETLK	8		; APPLEtalk			*/
%define ARPHRD_DLCI	15		; Frame Relay DLCI		*/
%define ARPHRD_ATM	19		; ATM 				*/
%define ARPHRD_METRICOM	23		; Metricom STRIP (new IANA id)	*/
%define	ARPHRD_IEEE1394	24		; IEEE 1394 IPv4 - RFC 2734	*/
%define ARPHRD_EUI64	27		; EUI-64                       */
%define ARPHRD_INFINIBAND 32		; InfiniBand			*/

; Dummy types for non ARP hardware */
%define ARPHRD_SLIP	256
%define ARPHRD_CSLIP	257
%define ARPHRD_SLIP6	258
%define ARPHRD_CSLIP6	259
%define ARPHRD_RSRVD	260		; Notional KISS type 		*/
%define ARPHRD_ADAPT	264
%define ARPHRD_ROSE	270
%define ARPHRD_X25	271		; CCITT X.25			*/
%define ARPHRD_HWX25	272		; Boards with X.25 in firmware	*/
%define ARPHRD_CAN	280		; Controller Area Network      */
%define ARPHRD_PPP	512
%define ARPHRD_CISCO	513		; Cisco HDLC	 		*/
%define ARPHRD_HDLC	ARPHRD_CISCO
%define ARPHRD_LAPB	516		; LAPB				*/
%define ARPHRD_DDCMP    517		; Digital's DDCMP protocol     */
%define ARPHRD_RAWHDLC	518		; Raw HDLC			*/

%define ARPHRD_TUNNEL	768		; IPIP tunnel			*/
%define ARPHRD_TUNNEL6	769		; IP6IP6 tunnel       		*/
%define ARPHRD_FRAD	770             ; Frame Relay Access Device    */
%define ARPHRD_SKIP	771		; SKIP vif			*/
%define ARPHRD_LOOPBACK	772		; Loopback device		*/
%define ARPHRD_LOCALTLK 773		; Localtalk device		*/
%define ARPHRD_FDDI	774		; Fiber Distributed Data Interface */
%define ARPHRD_BIF      775             ; AP1000 BIF                   */
%define ARPHRD_SIT	776		; sit0 device - IPv6-in-IPv4	*/
%define ARPHRD_IPDDP	777		; IP over DDP tunneller	*/
%define ARPHRD_IPGRE	778		; GRE over IP			*/
%define ARPHRD_PIMREG	779		; PIMSM register interface	*/
%define ARPHRD_HIPPI	780		; High Performance Parallel Interface */
%define ARPHRD_ASH	781		; Nexus 64Mbps Ash		*/
%define ARPHRD_ECONET	782		; Acorn Econet			*/
%define ARPHRD_IRDA 	783		; Linux-IrDA			*/
; ARP works differently on different FC media .. so  */
%define ARPHRD_FCPP	784		; Point to point fibrechannel	*/
%define ARPHRD_FCAL	785		; Fibrechannel arbitrated loop */
%define ARPHRD_FCPL	786		; Fibrechannel public loop	*/
%define ARPHRD_FCFABRIC	787		; Fibrechannel fabric		*/
	; 787->799 reserved for fibrechannel media types */
%define ARPHRD_IEEE802_TR 800		; Magic type ident for TR	*/
%define ARPHRD_IEEE80211 801		; IEEE 802.11			*/
%define ARPHRD_IEEE80211_PRISM 802	; IEEE 802.11 + Prism2 header  */
%define ARPHRD_IEEE80211_RADIOTAP 803	; IEEE 802.11 + radiotap header */

%define ARPHRD_VOID	  0xFFFF	; Void type, nothing is known */
%define ARPHRD_NONE	  0xFFFE	; zero header length */

; ARP protocol opcodes. */
%define	ARPOP_REQUEST	1		; ARP request			*/
%define	ARPOP_REPLY	2		; ARP reply			*/
%define	ARPOP_RREQUEST	3		; RARP request			*/
%define	ARPOP_RREPLY	4		; RARP reply			*/
%define	ARPOP_InREQUEST	8		; InARP request		*/
%define	ARPOP_InREPLY	9		; InARP reply			*/
%define	ARPOP_NAK	10		; (ATM)ARP NAK			*/

;32bit mode sys_socketcall
%define RECVMSG 17
%define SENDMSG 16
%define GETSOCKOPT 15
%define SETSOCKOPT 14
%define SHUTDOWN 13
%define RECVFROM 12
%define SENDTO 11
%define RECV 10
%define SEND 9
%define SOCKETPAIR 8
%define GETPEERNAME 7
%define GETSOCKNAME 6
%define ACCEPT 5
%define LISTEN 4
%define CONNECT 3
%define BIND 2
%define SOCKET 1