;ASM ;autor yesma
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
write_ethdr:
cld
	mov esi,sMac
	mov cx,sMac_ile
	add bx,cx
	rep movsb
	mov esi,eth + ethhdr.h_source
call wr_mac
	mov esi,dMac
	mov cx,dMac_ile
	add bx,cx
	rep movsb
	mov esi,eth + ethhdr.h_dest
call wr_mac
	mov esi,hProt
	mov cx,hProt_ile
	add bx,cx
	rep movsb
	mov ax,[eth + ethhdr.h_proto]
	ror ax,8
call htoa16
	mov al,0ah
	stosb
	inc bx
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
write_iphdr:
cld
	mov esi,kom_ver
	mov cx,kom_ver_ile
	add bx,cx
	rep movsb
	mov al,[ip + iphdr.ip_version]
	shr al,4
call htoa
	mov esi,kom_hl
	mov cx,kom_hl_ile
	add bx,cx
	rep movsb
	mov al,[ip + iphdr.ip_version] 		;ipLen
	and al,00001111b
	shl al,2
call htoa
	mov esi,kom_tos
	mov cx,kom_tos_ile
	add bx,cx
	rep movsb
	mov al,[ip + iphdr.ip_tos]
call htoa
	mov esi,kom_len
	mov cx,kom_len_ile
	add bx,cx
	rep movsb
	mov ax,[ip + iphdr.ip_total_length]
	ror ax,8
call htoa16
	mov esi,kom_id
	mov cx,kom_id_ile
	add bx,cx
	rep movsb
	mov ax,[ip + iphdr.ip_id]
	ror ax,8
call htoa16
	mov esi,kom_fl
	mov cx,kom_fl_ile
	add bx,cx
	rep movsb
	mov ax,[ip + iphdr.ip_flags]
	shr al,5
call htoa
	mov esi,kom_FragOff
	mov cx,kom_FragOff_ile		;fragment offset
	add bx,cx
	rep movsb
	mov ax,[ip + iphdr.ip_flags]
	ror ax,8
	and ah,00011111b
call htoa16
	mov esi,kom_ttl
	mov cx,kom_ttl_ile
	add bx,cx
	rep movsb
	mov al,[ip + iphdr.ip_ttl]
call htoa
	mov esi,kom_prot
	mov cx,kom_prot_ile
	add bx,cx
	rep movsb
	mov al,[ip + iphdr.ip_protocol]
call htoa
	mov esi,kom_cksum
	mov cx,kom_cksum_ile
	add bx,cx
	rep movsb
	mov ax,[ip + iphdr.ip_cksum]
	ror ax,8
call htoa16
	mov esi,kom_src
	mov cx,kom_src_ile
	add bx,cx
	rep movsb
	mov esi,ip + iphdr.ip_source
call write_ip
	mov esi,kom_dst
	mov cx,kom_dst_ile
	add bx,cx
	rep movsb
	mov esi,ip + iphdr.ip_dest
call write_ip
	mov al,0ah
	stosb
	inc bx
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	mov cx,[ip_options_ile]
	cmp cx,0
	jz .no_ipopt
push cx
	mov esi,kom_ipopt
	mov cx,kom_ipopt_ile
	add bx,cx
	cld
	rep movsb
	mov esi,ip + iphdr.ip_options
pop cx
call h2hex
.no_ipopt:
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
write_tcphdr:
cld
	mov esi,kom_src
	mov cx,kom_src_ile		;Sport
	add bx,cx
	rep movsb
	mov ax,[tcp + tcphdr.tcp_sport]
	ror ax,8
call htoa16
	mov esi,kom_dst
	mov cx,kom_dst_ile		;Dport
	add bx,cx
	rep movsb
	mov ax,[tcp + tcphdr.tcp_dport]
	ror ax,8
call htoa16
	mov esi,kom_seq
	mov cx,kom_seq_ile		;SeqNr
	add bx,cx
	rep movsb
	mov eax,[tcp + tcphdr.tcp_seqno]
	bswap eax
call htoa32
	mov esi,kom_ackno
	mov cx,kom_ackno_ile		;AckNr
	add bx,cx
	rep movsb
	mov eax,[tcp + tcphdr.tcp_ackno]
	bswap eax
call htoa32
	mov esi,kom_hl
	mov cx,kom_hl_ile				;tcp HeadLen
	add bx,cx
	rep movsb
	mov al,[tcp + tcphdr.tcp_hlen]
	shr al,4
	shl al,2
call htoa
	mov esi,kom_winsize
	mov cx,kom_winsize_ile				;WinSize
	add bx,cx
	rep movsb
	mov ax,[tcp + tcphdr.tcp_winsize]
	ror ax,8
call htoa16
	mov esi,kom_cksum
	mov cx,kom_cksum_ile				;tcp sum
	add bx,cx
	rep movsb
	mov ax,[tcp + tcphdr.tcp_cksum]
	ror ax,8
call htoa16
	mov esi,kom_urg
	mov cx,kom_urg_ile
	add bx,cx
	rep movsb
	mov ax,[tcp + tcphdr.tcp_urgent]
	ror ax,8
call htoa16
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	mov esi,kom_fl
	mov cx,kom_fl_ile
	add bx,cx
	rep movsb
	xor ch,ch
	mov cl,[tcp + tcphdr.th_flags]

	bt cx,7
	jnc ._ece
	mov edx,CWR
	mov eax,[edx]
	stosd
	add bx,4
._ece:
	bt cx,6
	jnc ._urg
	mov edx,ECE
	mov eax,[edx]
	stosd
	add bx,4
._urg:
	bt cx,5
	jnc ._ack
	mov edx,URG
	mov eax,[edx]
	stosd
	add bx,4
._ack:
	bt cx,4
	jnc ._psh
	mov edx,ACK
	mov eax,[edx]
	stosd
	add bx,4
._psh:
	bt cx,3
	jnc ._rst
	mov edx,PSH
	mov eax,[edx]
	stosd
	add bx,4
._rst:
	bt cx,2
	jnc ._syn
	mov edx,RST
	mov eax,[edx]
	stosd
	add bx,4
._syn:
	bt cx,1
	jnc ._fin
	mov edx,SYN
	mov eax,[edx]
	stosd
	add bx,4
._fin:
	bt cx,0
	jnc ._endf
	mov edx,FIN
	mov eax,[edx]
	stosd
	add bx,4
._endf:
	mov al,0ah
	stosb
	inc bx
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ tcpopt
	mov cx,[tcp_options_ile]
	cmp cx,0
	jz .no_tcpopt		;wiecej niz 40 sie nieda bo calosc gora 60 len 4bity
push cx
	mov esi,kom_tcpopt
	mov cx,kom_tcpopt_ile
	add bx,cx
	cld
	rep movsb
;esi data , rdi buf na string , rcx ile bajtow
	mov esi,tcp + tcphdr.tcp_options
pop cx
call h2hex
.no_tcpopt:
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
write_udphdr:
cld
	mov esi,kom_src
	mov cx,kom_src_ile				;Sport
	add bx,cx
	rep movsb
	mov ax,[udp + udphdr.sport]
	ror ax,8
call htoa16
	mov esi,kom_dst
	mov cx,kom_dst_ile				;Dport
	add bx,cx
	rep movsb
	mov ax,[udp + udphdr.dport]
	ror ax,8
call htoa16
	mov esi,kom_hl
	mov cx,kom_hl_ile				;HeadLen
	add bx,cx
	rep movsb
	mov al,[udp + udphdr.len]
	ror ax,8
call htoa16
	mov esi,kom_cksum
	mov cx,kom_cksum_ile				; sum
	add bx,cx
	rep movsb
	mov ax,[udp + udphdr.sum]
	ror ax,8
call htoa16
	mov al,0ah
	stosb
	inc bx
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
write_icmphdr:
cld
	mov esi,kom_type
	mov cx,kom_type_ile
	add bx,cx
	rep movsb
	mov al,[icmp + icmphdr.type]
call htoa
	mov esi,kom_code
	mov cx,kom_code_ile
	add bx,cx
	rep movsb
	mov al,[icmp + icmphdr.code]
call htoa
	mov esi,kom_cksum
	mov cx,kom_cksum_ile
	add bx,cx
	rep movsb
	mov ax,[icmp + icmphdr.sum]
	ror ax,8
call htoa16
	mov esi,kom_id
	mov cx,kom_id_ile
	add bx,cx
	rep movsb
	mov ax,[icmp + icmphdr.id]
	ror ax,8
call htoa16
	mov esi,kom_seq
	mov cx,kom_seq_ile
	add bx,cx
	rep movsb
	mov ax,[icmp + icmphdr.seq]
	ror ax,8
call htoa16
	mov al,0ah
	stosb
	inc bx
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
write_arphdr:
cld
	mov esi,kom_form
	mov cx,kom_form_ile
	add bx,cx
	rep movsb
	mov ax,[arp + arphdr.ar_hrd];		/* format of hardware address	*/
	ror ax,8
call htoa16
	mov esi,kom_prot
	mov cx,kom_prot_ile
	add bx,cx
	rep movsb
	mov ax,[arp + arphdr.ar_pro];		/* format of protocol address	*/
	ror ax,8
call htoa16
	mov esi,kom_len
	mov cx,kom_len_ile
	add bx,cx
	rep movsb
	mov al,[arp + arphdr.ar_hln];		/* length of hardware address	*/
call htoa
	mov esi,kom_len
	mov cx,kom_len_ile
	add bx,cx
	rep movsb
	mov al,[arp + arphdr.ar_pln];		/* length of protocol address	*/
call htoa
	mov esi,kom_comm
	mov cx,kom_comm_ile
	add bx,cx
	rep movsb
	mov ax,[arp + arphdr.ar_op];		/* ARP opcode (command)	np ARPOP_REQUEST
	ror ax,8
call htoa16
	mov esi,kom_src
	mov cx,kom_src_ile
	add bx,cx
	rep movsb
	mov esi,arp + arphdr.ar_sha		;/* sender hardware address	*/
;	mov cx,[arp + arphdr.ar_hln];		/* length of hardware address	*/
call wr_mac
	mov esi,kom_src
	mov cx,kom_src_ile
	add bx,cx
	rep movsb
	mov esi,arp + arphdr.ar_sip	;	/* sender IP address		*/
call write_ip
	mov esi,kom_dst
	mov cx,kom_dst_ile
	add bx,cx
	rep movsb
	mov esi,arp + arphdr.ar_tha		;/* target hardware address	*/
call wr_mac
	mov esi,kom_dst
	mov cx,kom_dst_ile
	add bx,cx
	rep movsb
	mov esi,arp + arphdr.ar_tip		;/* target IP address		*/
call write_ip
	mov al,0ah
	stosb
	inc bx
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
write_igmphdr:					;multicast
	mov esi,kom_type
	mov cx,kom_type_ile
	add bx,cx
	rep movsb
	mov al,[igmp + igmphdr.type]
call htoa
	mov esi,kom_code
	mov cx,kom_code_ile
	add bx,cx
	rep movsb
	mov al,[igmp + igmphdr.code]
call htoa
	mov esi,kom_cksum
	mov cx,kom_cksum_ile
	add bx,cx
	rep movsb
	mov ax,[igmp + igmphdr.csum]
	ror ax,8
call htoa16
	mov esi,kom_grp
	mov cx,kom_grp_ile
	add bx,cx
	rep movsb
	mov eax,[igmp + igmphdr.group]
	bswap eax
call htoa32
	mov al,0ah
	stosb
	inc bx
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
htoa:
;rdi buf al,hex
	xor ecx,ecx
	mov dl,10

	xor ah,ah
	div dl
	or ah,30h
	mov cl,ah
	cmp al,0
	je .en
	shl ecx,8
	xor ah,ah
	div dl
	or ah,30h
	mov cl,ah
	cmp al,0
	je .en
	shl ecx,8
	xor ah,ah
	div dl
	or ah,30h
	mov cl,ah
.en:
	mov eax,ecx
	cmp al,0
	je .a
	stosb
	inc bx
	shr eax,8
	cmp al,0
	je .a
	stosb
	inc bx
	shr eax,8
	cmp al,0
	je .a
	stosb
	inc bx
.a:
xor ecx,ecx
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
htoa16:
section .bss
	.buf		resb 8
section .text
;rdi buf ax,hex		ascii 5 cyfer
	mov si,10
push edi
	xor cx,cx
	mov edi,.buf

	xor dx,dx
	div si
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp ax,0
	je .en1
	xor dx,dx
	div si
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp ax,0
	je .en1
	xor dx,dx
	div si
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp ax,0
	je .en1
	xor dx,dx
	div si
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp ax,0
	je .en1
	xor dx,dx
	div si
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
.en1:
	mov esi,edi
pop edi

.loop:
	dec esi
	movsb
	dec esi
	loop .loop
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
htoa32:						;hex dword to ascii arg:eax
;eax rdi
section .bss
	.buf		resb 12			;10 + pad
section .text
push edi
xor cx,cx
	mov edi,.buf
	mov esi,10

	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp eax,0
	je near .en2
	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp eax,0
	je near .en2
	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp eax,0
	je near .en2
	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp eax,0
	je .en2
	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp eax,0
	je .en2
	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp eax,0
	je .en2
	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp eax,0
	je .en2
	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp eax,0
	je .en2
	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
	cmp eax,0
	je .en2
	xor edx,edx
	div esi
	or dl,30h
	mov [edi],dl
	inc edi
	inc bx
	inc cl
.en2:
	mov esi,edi
pop edi
.loop:
	dec esi
	movsb
	dec esi
	loop .loop
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
wr_mac:							;int to hex string arg:al
;esi data , rdi buf na string ,
mov cx,6
.loop:
push cx
	xor cx,cx
	mov dl,16
	lodsb

	xor ah,ah
	div dl
	cmp ah,9
	jbe  .cyf
	add ah,7h
.cyf:
	add ah,30h
	mov cl,ah
	shl cx,8

	xor ah,ah
	div dl
	cmp ah,9
	jbe  .cyf1
	add ah,7h
.cyf1:
	add ah,30h
	mov cl,ah

	mov ax,cx
	stosw
	mov al,":"
	stosb
	add bx,3
pop cx
	loop .loop
	dec edi
	dec bx
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
write_ip:
;esi data , rdi buf na string
mov cx,4
.loop:
push ecx

	xor ecx,ecx
	mov dl,10
	lodsb

	xor ah,ah
	div dl
	or ah,30h
	mov cl,ah
	cmp al,0
	je .dal
	shl ecx,8
	xor ah,ah
	div dl
	or ah,30h
	mov cl,ah
	cmp al,0
	je .dal
	shl ecx,8
	xor ah,ah
	div dl
	or ah,30h
	mov cl,ah
.dal:
	mov eax,ecx
	cmp al,0
	je .end
	stosb
	inc bx
	shr eax,8
	cmp al,0
	je .end
	stosb
	inc bx
	shr eax,8
	cmp al,0
	je .end
	stosb
	inc bx
.end:
	mov al,"."
	stosb
	inc bx
pop ecx
	loop .loop
	dec edi
	dec bx
;xor ecx,ecx			;to niepotrzebne bo cx == 0
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
h2str:							;int to hex string arg:al
;esi data , rdi buf na string , rcx ile bajtow
push cx
	xor cx,cx
	mov dl,16
	lodsb
;~~~~~~~~~~~~~~~~~~~~~~~~~ znaki ascii pozostawiam nietkniete
	cmp al,09h
	je .specj
	cmp al,0ah
	je .specj
	cmp al,0dh
	je .specj
; od spacji
	cmp al,20h
	jb .dalej
	cmp al,7eh
	ja .dalej
;do tyldy
;~~~~~~~~~~~~~~~~~~~~~~~~~
.specj:
	stosb
	inc ebx
	jmp .aaaa
.dalej:
;~~~~~~~~~~~~~~~~~~~~~~~~~
	xor ah,ah
	div dl
	cmp ah,9
	jbe  .cyf
	add ah,7h
.cyf:
	add ah,30h
	mov cl,ah
	shl cx,8

	xor ah,ah
	div dl
	cmp ah,9
	jbe  .cyf1
	add ah,7h
.cyf1:
	add ah,30h
	mov cl,ah

	cmp cl,"A"
	jb .ddd
	mov al,30h		;jak zaczyna sie A do F to daje przed 0
	stosb
	inc ebx
.ddd:
	mov ax,cx
	stosw
	add ebx,2
	mov ax,"h,"		;na koncu daje h, np 0FFh,
	stosw
	inc ebx
	inc ebx
.aaaa:
pop cx
	loop h2str

	mov al,0ah
	stosb
	inc ebx
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
h2hex:							;int to hex string arg:al
;esi data , rdi buf na string , rcx ile bajtow
push cx
	xor cx,cx
	mov dl,16
	lodsb
;~~~~~~~~~~~~~~~~~~~~~~~~~
	xor ah,ah
	div dl
	cmp ah,9
	jbe  .cyf
	add ah,7h
.cyf:
	add ah,30h
	mov cl,ah
	shl cx,8

	xor ah,ah
	div dl
	cmp ah,9
	jbe  .cyf1
	add ah,7h
.cyf1:
	add ah,30h
	mov cl,ah

	cmp cl,"A"
	jb .ddd
	mov al,30h		;jak zaczyna sie A do F to daje przed 0
	stosb
	inc ebx
.ddd:
	mov ax,cx
	stosw
	add ebx,2
	mov ax,"h,"
	stosw
	inc ebx
	inc ebx
.aaaa:
pop cx
	loop h2hex

	mov al,0ah
	stosb
	inc ebx
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
